#####################################################################################
#  sbw3.tcl                                                                #
#  3.4.4                                                                      #
# by Dark_Agent (darkagent@yandex.ru)                                               #
#   :   http://darkagent.pp.ru                                #
#   : http://darkagent.narod.ru                             #
#    :   http://forum.eggdrop.org.ru/index.php?showtopic=367   #
# since 03.03.2005                                                                  #
#####################################################################################

foreach p [array names smartrm *] { catch {unset smartrm($p) } }



namespace eval smartrm {
  set bwversion 3.4.4
  set bwcp1251 1
  set debug 1
  setudef flag badwords
  setudef flag bwbanquits
## 
  setudef str bwactionr
  setudef str bwactionv
  setudef str bwactionh
  setudef str bwactiono
##
  setudef str bwwarnmoder
  setudef str bwwarnmodev
  setudef str bwwarnmodeh
  setudef str bwwarnmodeo
##
  setudef str bwwarnmsgr
  setudef str bwwarnmsgv
  setudef str bwwarnmsgh
  setudef str bwwarnmsgo
##
  setudef str bwbanmsgr
  setudef str bwbanmsgv
  setudef str bwbanmsgh
##  
  set DefaultMessage "  !"
  set DefaultTime 10
##
  setudef int bwbantimer
  setudef int bwbantimev
  setudef int bwbantimeh
##
  setudef int bwwarntimer
  setudef int bwwarntimev
  setudef int bwwarntimeh
  setudef int bwwarntimeo
##
  set bwfile "bw.txt"
  set bwefile "bwe.txt"
  set kickcount 0
##
  setudef int bwbanmask
##
  set sbanmask 1 
	# 1 - *!*@some.host.com
	# 2 - *!*@*.host.com
	# 3 - *!*ident@some.domain.com
	# 4 - *!*ident@*.host.com
	# 5 - *!*ident*@*.host.com
	# 6 - *!*ident*@some.host.com
	# 7 - nick*!*@*.host.com
	# 8 - *nick*!*@*.host.com
	# 9 - nick*!*@some.host.com
	# 10 - *nick*!*@some.host.com
	# 11 - nick!ident@some.host.com
	# 12 - nick!ident@*.host.com
	# 13 - *nick*!*ident@some.host.com
	# 14 - nick*!*ident*@some.host.com
	# 15 - *nick*!*ident*@some.host.com
	# 16 - nick!*ident*@some.host.com
	# 17 - nick*!*ident@*.host.com
	# 18 - nick*!*ident*@*.host.com
	# 19 - *nick*!*ident@*.host.com
	# 20 - *nick*!*ident*@*.host.com

  set BadWords ""
  set BadExepts ""
  set WarnList ""
  set BlackList ""
##
## Language definitions
  set lng_bwloaded                   " sbw.tcl  $bwversion ."
  set lng_combexists                 "\0033     \003"
  set lng_combadded                  "\0033 \003"
  set lng_combnotf                   "\0033  \003"
  set lng_combdeleted                "\0033 \003"
  set lng_badtopic                   "  "
  set lng_banned                     " "
  set lng_minutes                    ""
  set lng_bwonchan                   "\0033  \003"
  set lng_on                         "\0033\003"
  set lng_off                        "\0033\003"
  set lng_cfnotf                     "   ,  "
  set lng_chwarntime                 "  \:"
  set lng_chwarntimeuse              "\: !bwwarntime  "
  set lng_chwarntimetargets          "\: r ( ) v () h () o ()"
  set lng_chwarntimeexample          " !bwwarntime v 25   -  25    "  
  set lng_chwarntimefor              "   "
  set lng_forop                      ""
  set lng_forhop                     ""
  set lng_forvoice                   ""
  set lng_forreg                     " "
  set lng_modena                     "   "
  set lng_wrongargs                  "  "
  set lng_chbantime                  "  \:"
  set lng_chbantimeuse               "\: !bwbantime  "
  set lng_chbantimetargets           "\: r ( ) v () h ()"
  set lng_chbantimeexample           " !bwwarntime v 25   -  25    "
  set lng_chbantimefor               "   "
  set lng_chebanmsguse               "\: \!bwbanmsg  "
  set lng_chebanmsgtargets           "\: r ( ) v () h ()"
  set lng_chebanmsgexample           "\: !bwbanmsg r  "
  set lng_chebanmsgfor               "- "
  set lng_chewarnmsguse              "\: \!bwwarnmsg  "
  set lng_chewarnmsgtargets          "\: r ( ) v () h () o ()"
  set lng_chewarnmsgexample          "\: !bwwarnmsg r  "
  set lng_warnfor                    " "

  set lng_chewarnmuse                "\: \!bwwarnmode  "
  set lng_chewarnmtargets            "\: r ( ) v () h () o ()"
  set lng_chewarnmmode               "\: notice () private ( ) channel ( )"
  set lng_chewarnmexample            "\: !bwwarnmode r notice"
  set lng_wrongmode                  "  "
  set lng_chewarnm                   "   "

  set lng_cheactmuse                 "\: \!bwactmode  "
  set lng_cheactmtargets             "\: r ( ) v () h () o ()"
  set lng_cheactmmode                "\: none () w () k () b (),  \: wk, kb, wkb, wb, v"
  set lng_cheactmexample             "\: !bwactmode r kb"
  set lng_cheactm                    "  "
  set lng_wrongactmodeo              "  ,   :\ none, k, w, wk"

  set lng_bmaskuse1                  "\: \!bwbanmask -"
  set lng_bmaskuse2                  " -\: !bwbanmask list"  
  set lng_bmaskcur                   "  -"
  set lng_bmaskwrongnum              "    ,  "
  set lng_bmaskselected              "   "

  set lng_bwstats                    "\0033\037 :\037\003"
  set lng_badwords                   "\0033 \003 "
  set lng_excepts                    "\0033\003"
  set lng_totalcount                 "\0033     \003"
  set lng_times                      "\0033\003"

  set lng_curconfig                  "\037\0033    \003\037\:"
  set lng_curmode                    "                   "
  set lng_curwarn                    "             "
  set lng_curwarntime                "  ( )"
  set lng_curbantime                 "            ( )"

  set lng_bwvermsg1                  "\037\0033 \003\037\: \00312$bwversion\003"
  set lng_bwvermsg2                  "\037\0033\003\037\:            Dark_Agent \(mailto\:\0039darkagent\@yandex\.ru\003\)"
  set lng_bwvermsg3                  "\037\0033\003\037\:        Handbrake aka crackadil\, Shrike\, CoolCold\, tigra\, S0lver"
  set lng_bwvermsg4                  "\037\0033\003\037\:         sbw.tcl"
  set lng_bwvermsg5                  "\037\0033\003\037\:         http\:\/\/darkagent.narod.ru"

  set lng_bwhelp1                    "\037\0033  \003\037\:"
  set lng_bwhelp2                    "/\: !bwon / !bwoff"
  set lng_bwhelp3                    "/ \: !bwadd / !bwdel"
  set lng_bwhelp4                    "/ \: !bweadd / !bwedel"
  set lng_bwhelp5                    " \: !bwactmode, !bwwarnmode, !bwbanmask"
  set lng_bwhelp6                    " \: !bwwarntime, !bwbantime"
  set lng_bwhelp7                    " \: !bwwarnmsg, !bwbanmsg"
  set lng_bwhelp8                    ", \: !bwstats, !bwstatus"
  set lng_bwhelp9                    " \: !bwbanquits"

  set lng_changenick                 "     -  ,    "

  set lng_bwchans                    "\0033    \003\:"

  set lng_bwbanquits                 "\0033     \003"
  set lng_bwbanquitsuse              "\: !bwbanquits \[on\|off\|0\|1\]"
  set lng_bwbanquitson               "       \037\037"
  set lng_bwbanquitsoff              "       \037\037"
} 


proc ::smartrm::checkdefaults { chan } {
 variable DefaultMessage; variable DefaultTime;
##
 if { ![bw:active $chan] } { return 0 }
 set testmode ""
 set testmode "[channel get $chan bwactionr]"
 if { ![string match "none" $testmode] && ![string match "k" $testmode] && ![string match "b" $testmode] && ![string match "w" $testmode] && ![string match "wk" $testmode] && ![string match "kb" $testmode] && ![string match "wb" $testmode] && ![string match "wkb" $testmode]} { channel set $chan bwactionr "none" }
 set testmode "[channel get $chan bwactionv]"
 if { ![string match "none" $testmode] && ![string match "k" $testmode] && ![string match "b" $testmode] && ![string match "w" $testmode] && ![string match "wk" $testmode] && ![string match "kb" $testmode] && ![string match "wb" $testmode] && ![string match "wkb" $testmode] && ![string match "v" $testmode]} { channel set $chan bwactionv "none" }
 set testmode "[channel get $chan bwactionh]"
 if { ![string match "none" $testmode] && ![string match "k" $testmode] && ![string match "b" $testmode] && ![string match "w" $testmode] && ![string match "wk" $testmode] && ![string match "kb" $testmode] && ![string match "wb" $testmode] && ![string match "wkb" $testmode"]} { channel set $chan bwactionh "none" }
 set testmode "[channel get $chan bwactiono]"
 if { ![string match "none" $testmode] && ![string match "k" $testmode] && ![string match "w" $testmode] && ![string match "wk" $testmode] } { channel set $chan bwactiono "none" }
##
 set testmode "[channel get $chan bwwarnmoder]"
 if { ![string match "notice" $testmode] && ![string match "private" $testmode] && ![string match "channel" $testmode]} { channel set $chan bwwarnmoder "notice" } 
 set testmode "[channel get $chan bwwarnmodev]"
 if { ![string match "notice" $testmode] && ![string match "private" $testmode] && ![string match "channel" $testmode]} { channel set $chan bwwarnmodev "notice" } 
 set testmode "[channel get $chan bwwarnmodeh]"
 if { ![string match "notice" $testmode] && ![string match "private" $testmode] && ![string match "channel" $testmode]} { channel set $chan bwwarnmodeh "notice" } 
 set testmode "[channel get $chan bwwarnmodeo]"
 if { ![string match "notice" $testmode] && ![string match "private" $testmode] && ![string match "channel" $testmode]} { channel set $chan bwwarnmodeo "notice" } 
##
 set testmode "[channel get $chan bwwarnmsgr]"
 if {$testmode == ""} { channel set $chan bwwarnmsgr $DefaultMessage }
 set testmode "[channel get $chan bwwarnmsgv]"
 if {$testmode == ""} { channel set $chan bwwarnmsgv $DefaultMessage }
 set testmode "[channel get $chan bwwarnmsgh]"
 if {$testmode == ""} { channel set $chan bwwarnmsgh $DefaultMessage }
 set testmode "[channel get $chan bwwarnmsgo]"
 if {$testmode == ""} { channel set $chan bwwarnmsgo $DefaultMessage }
##
 set testmode "[channel get $chan bwbanmsgr]"
 if {$testmode == ""} { channel set $chan bwbanmsgr $DefaultMessage }
 set testmode "[channel get $chan bwbanmsgv]"
 if {$testmode == ""} { channel set $chan bwbanmsgv $DefaultMessage }
 set testmode "[channel get $chan bwbanmsgh]"
 if {$testmode == ""} { channel set $chan bwbanmsgh $DefaultMessage }
##
 set testmode1 0
 set testmode1 [channel get $chan bwbantimer]
 if {$testmode1 == 0} { channel set $chan bwbantimer $DefaultTime }
 set testmode1 [channel get $chan bwbantimev]
 if {$testmode1 == 0} { channel set $chan bwbantimev $DefaultTime }
 set testmode1 [channel get $chan bwbantimeh]
 if {$testmode1 == 0} { channel set $chan bwbantimeh $DefaultTime }
##
 set testmode1 [channel get $chan bwwarntimer]
 if {$testmode1 == 0} { channel set $chan bwwarntimer $DefaultTime }
 set testmode1 [channel get $chan bwwarntimev]
 if {$testmode1 == 0} { channel set $chan bwwarntimev $DefaultTime }
 set testmode1 [channel get $chan bwwarntimeh]
 if {$testmode1 == 0} { channel set $chan bwwarntimeh $DefaultTime }
 set testmode1 [channel get $chan bwwarntimeo]
 if {$testmode1 == 0} { channel set $chan bwwarntimeo $DefaultTime }
##
 set testmode1 [channel get $chan bwbanmask]
 if {$testmode1 < 1 && $testmode1 > 20 } { channel set $chan bwbanmask 1 }
}

proc ::smartrm::getbantime { nick chan } {
 set bantime [channel get $chan bwbantimer]
 if {[isvoice $nick $chan]} { set bantime [channel get $chan bwbantimev] }
 if {[ishalfop $nick $chan]} { set bantime [channel get $chan bwbantimeh] }
 return $bantime
}

proc ::smartrm::getwarntime { nick chan } {
 set warntime [channel get $chan bwwarntimer]
 if {[isvoice $nick $chan]} { set warntime [channel get $chan bwwarntimev] }
 if {[ishalfop $nick $chan]} { set warntime [channel get $chan bwwarntimeh] }
 if {[isop $nick $chan]} { set warntime [channel get $chan bwwarntimeo] }
 return $warntime
}

proc ::smartrm::getwarnmsg { nick chan } {
 set warnmsg "[channel get $chan bwwarnmsgr]"
 if {[isvoice $nick $chan]} { set warnmsg [channel get $chan bwwarnmsgv] }
 if {[ishalfop $nick $chan]} { set warnmsg [channel get $chan bwwarnmsgh] }
 if {[isop $nick $chan]} { set warnmsg [channel get $chan bwwarnmsgo] }
 return "$warnmsg"
}  

proc ::smartrm::getbanmsg { nick chan } {
 set banmsg "[channel get $chan bwbanmsgr]"
 if {[isvoice $nick $chan]} { set banmsg [channel get $chan bwbanmsgv] }
 if {[ishalfop $nick $chan]} { set banmsg [channel get $chan bwbanmsgh] }
 return "$banmsg"
}  


proc ::smartrm::bwload { } {
 variable lng_bwloaded; variable BadWords; variable bwfile; variable bwefile; variable BadExepts; variable bwcp1251;
    if { $bwcp1251 == 1 } {
       encoding system iso8859-1
       } else {
       encoding system koi8-r
       }
    set file [open $bwfile]
    set BadWords [read $file]
    close $file
    set file [open $bwefile]
    set BadExepts [read $file]
    close $file
    putcmdlog "TCL Script> $lng_bwloaded"
}

proc ::smartrm::bwadd {nick uhost hand text} {
 variable lng_combexists; variable lng_combadded;
 variable bwfile; variable BadWords;
 if {[llength $text] == 0 } {
   putserv "NOTICE $nick :!bwadd <>"
   return 0
   }
 set file [open $bwfile]
 set BadWords [read $file]
 close $file
 set text [tolower $text]
 set line $text
 regsub -all " " $line !SP! line
 regsub -all {\\} $line !SL! line
 regsub -all {\<} $line !LT! line
 regsub -all {\>} $line !GT! line
 regsub -all {\"} $line !QT! line
 regsub -all {\(} $line !LP! line
 regsub -all {\)} $line !RP! line
 regsub -all {\{} $line !LB! line
 regsub -all {\}} $line !RB! line
 regsub -all {\[} $line !LF! line
 regsub -all {\]} $line !RF! line
 regsub -all {\;} $line !QL! line
 regsub -all {\:} $line !CO! line 
 foreach bw $BadWords {
 if {[string match $bw $line]} {
     putserv "NOTICE $nick :$lng_combexists"
     return 0
     }
 } 
 set file [open $bwfile a+]
 set line "$line  "
 puts $file $line
 close $file 
 putserv "NOTICE $nick :$lng_combadded"
 set file [open $bwfile]
 set BadWords [read $file]
 close $file
 return 1
}

proc ::smartrm::bweadd {nick uhost hand text} {
 variable lng_combexists; variable lng_combadded;
 variable bwefile; variable BadExepts;
 if {[llength $text] == 0 } {
   putserv "NOTICE $nick :!bweadd <>"
   return 0
   }
 set file [open $bwefile]
 set BadExepts [read $file]
 close $file
 set text [tolower $text]
 set line $text
 regsub -all " " $line !SP! line
 regsub -all {\\} $line !SL! line
 regsub -all {\<} $line !LT! line
 regsub -all {\>} $line !GT! line
 regsub -all {\"} $line !QT! line
 regsub -all {\(} $line !LP! line
 regsub -all {\)} $line !RP! line
 regsub -all {\{} $line !LB! line
 regsub -all {\}} $line !RB! line
 regsub -all {\[} $line !LF! line
 regsub -all {\]} $line !RF! line
 regsub -all {\;} $line !QL! line
 regsub -all {\:} $line !CO! line 
 foreach bw $BadExepts {
 if {[string match $bw $line]} {
     putserv "NOTICE $nick :$lng_combexists"
     return 0
     }
 } 
 set file [open $bwefile a+]
 set line "$line  "
 puts $file $line
 close $file 
 putserv "NOTICE $nick :$lng_combadded"
 set file [open $bwefile]
 set BadExepts [read $file]
 close $file
 return 1
}


proc ::smartrm::bwdel {nick uhost hand text} {
 variable lng_combnotf; variable lng_combdeleted;
 variable BadWords; variable bwfile;
 if {[llength $text] == 0 } {
    putserv "NOTICE $nick :!bwdel <>"
    return 0
    }
 set file [open $bwfile]
 set BadWords [read $file]
 close $file
 set line $text
 regsub -all " " $line !SP! line
 regsub -all {\\} $line !SL! line
 regsub -all {\<} $line !LT! line
 regsub -all {\>} $line !GT! line
 regsub -all {\"} $line !QT! line
 regsub -all {\(} $line !LP! line
 regsub -all {\)} $line !RP! line
 regsub -all {\{} $line !LB! line
 regsub -all {\}} $line !RB! line
 regsub -all {\[} $line !LF! line
 regsub -all {\]} $line !RF! line
 regsub -all {\;} $line !QL! line
 regsub -all {\:} $line !CO! line 
 set bwind [lsearch $BadWords $line]  
 if {$bwind < 0} {
    putserv "NOTICE $nick :$lng_combnotf\: $line"
    return 0
    }
 set BadWords [lreplace $BadWords $bwind $bwind]
 set file [open $bwfile w]
 foreach i $BadWords {
   set i "$i  "
   puts $file $i
 }
 close $file

 putserv "NOTICE $nick :$lng_combdeleted"
 set file [open $bwfile]
 set BadWords [read $file]
 close $file
}

proc ::smartrm::bwedel {nick uhost hand text} {
 variable lng_combnotf; variable lng_combdeleted;
 variable BadExepts; variable bwefile;
 if {[llength $text] == 0 } {
    putserv "NOTICE $nick :!bwedel <>"
    return 0
    }
 set file [open $bwefile]
 set BadExepts [read $file]
 close $file
 set line $text
 regsub -all " " $line !SP! line
 regsub -all {\\} $line !SL! line
 regsub -all {\<} $line !LT! line
 regsub -all {\>} $line !GT! line
 regsub -all {\"} $line !QT! line
 regsub -all {\(} $line !LP! line
 regsub -all {\)} $line !RP! line
 regsub -all {\{} $line !LB! line
 regsub -all {\}} $line !RB! line
 regsub -all {\[} $line !LF! line
 regsub -all {\]} $line !RF! line
 regsub -all {\;} $line !QL! line
 regsub -all {\:} $line !CO! line 
 set bwind [lsearch $BadExepts $line]  
 if {$bwind < 0} {
    putserv "NOTICE $nick :$lng_combnotf\: $line"
    return 0
    }
 set BadExepts [lreplace $BadExepts $bwind $bwind]
 set file [open $bwefile w]
 foreach i $BadExepts {
   set i "$i  "
   puts $file $i
 }
 close $file
 putserv "NOTICE $nick :$lng_combdeleted"
 set file [open $bwefile]
 set BadExepts [read $file]
 close $file
}


proc bw:active {chan} {
  foreach setting [channel info $chan] {
   if {[regexp -- {^[\+-]} $setting]} {
    if {$setting == "+badwords"} { 
     return 1 
     }
    }
   }
  return 0
}



proc check:bots {hand chan} {
 set flag_ch [chattr $hand $chan]
 if {![regexp "bB" "$flag_ch"]} { return 1 }
 return 0
}

proc check:friend {hand chan} {
 set flag_ch [chattr $hand $chan]
 if {![regexp "f" "$flag_ch"]} { return 1 }
 return 0
}

proc ::smartrm::select_banmask {chan uhost nick} {
 set sbanmask [channel get $chan bwbanmask]
   switch -- $sbanmask {
     1 { set banmask "*!*@[lindex [split $uhost @] 1]" }
     2 { set banmask "*!*@[lindex [split [maskhost $uhost] "@"] 1]" }
     3 { set banmask "*!*$uhost" }
     4 { set banmask "*!*[lindex [split [maskhost $uhost] "!"] 1]" }
     5 { set banmask "*!*[lindex [split $uhost "@"] 0]*@[lindex [split [maskhost $uhost] "@"] 1]" }
     6 { set banmask "*!*[lindex [split $uhost "@"] 0]*@[lindex [split $uhost "@"] 1]" }
     7 { set banmask "$nick*!*@[lindex [split [maskhost $uhost] "@"] 1]" }
     8 { set banmask "*$nick*!*@[lindex [split [maskhost $uhost] "@"] 1]" }
     9 { set banmask "$nick*!*@[lindex [split $uhost "@"] 1]" }
    10 { set banmask "*$nick*!*@[lindex [split $uhost "@"] 1]" }
    11 { set banmask "$nick*!*[lindex [split $uhost "@"] 0]@[lindex [split $uhost @] 1]" }
    12 { set banmask "$nick*!*[lindex [split $uhost "@"] 0]@[lindex [split [maskhost $uhost] "@"] 1]" }
    13 { set banmask "*$nick*!*$uhost" }
    14 { set banmask "$nick*!*[lindex [split $uhost "@"] 0]*@[lindex [split $uhost "@"] 1]" }
    15 { set banmask "*$nick*!*[lindex [split $uhost "@"] 0]*@[lindex [split $uhost "@"] 1]" } 
    16 { set banmask "$nick!*[lindex [split $uhost "@"] 0]*@[lindex [split $uhost "@"] 1]" } 
    17 { set banmask "$nick![lindex [split $uhost "@"] 0]@[lindex [split [maskhost $uhost] "@"] 1]" }
    18 { set banmask "$nick!*[lindex [split $uhost "@"] 0]*@[lindex [split [maskhost $uhost] "@"] 1]" } 
    19 { set banmask "*$nick*!*[lindex [split $uhost "@"] 0]@[lindex [split [maskhost $uhost] "@"] 1]" }
    20 { set banmask "*$nick*!*[lindex [split $uhost "@"] 0]*@[lindex [split [maskhost $uhost] "@"] 1]" } 
    default { set banmask "*!*@[lindex [split $uhost @] 1]" }
    return $banmask
   }
}

proc ::smartrm::tolower {text} { return [string map {     } [string tolower $text]] }
proc ::smartrm::lat2rus {text} { return [string map {q  w  e  r  t  y  u  i  o  p  [  ]  a  s  d  f  g  h  j  k  l  ;  '  z  x  c  v  b  n  m  ,  .  / . Q  W  E  R  T  Y  U  I  O  P  \{  \}  A  S  D  F  G  H  J  K  L  :  \"  Z  X  C  V  B  N  M  <  >  ? , ^ : & ? `  ~  $ ;} $text] }
proc ::smartrm::is_rus {letter} {
  set caps {                                                                 }
  if {[lsearch -exact $caps $letter] > -1} {
	return 1
  } else {
	return 0
  }
}

proc ::smartrm::text_has_rus {text} {
  set len [string length $text]
  set cnt 0
  while {$cnt < $len} {
   if {[is_rus [string index $text $cnt]]} { return 1 }
   incr cnt
  }
  return 0
}

proc ::smartrm::is_rus {letter} {
  set caps {                                                                 }
  if {[lsearch -exact $caps $letter] > -1} { return 1  } else { return 0  }
}

proc ::smartrm::DetectMat {text} {
  variable BadWords; variable BadExepts;
  if { [info exists egg_codepage] } {
     global egg_codepage
     set text [encoding convertto iso8859-1 $text]
     set text [encoding convertfrom $egg_codepage $text]
     regsub -all {[\x02\x16\x1f]|\x03\d{0,2}(,\d{0,2})?} $text "" text
     set text [encoding convertto $egg_codepage $text]
     } else {
     set text [encoding convertfrom [encoding system] $text] 
     regsub -all {[\x02\x16\x1f]|\x03\d{0,2}(,\d{0,2})?} $text "" text
     }
  set text2 "$text"
  if {![text_has_rus $text2]} {
  set text2 "[lat2rus $text2]"
  regsub -all {([ \\`\~\!\@\#\$\%\^\&\*\(\)\_\-\+\=\{\}\[\]\;\:\'\"\<\>\.\,\/\?\|\\])+} $text2 " " text2;
  }
  set text [string map {A  a  B  C  c  E  e  H  K  k  M  O  o  P  p  T  U  u  X  x  Y  y  3  4  6  0  b  g  n } $text]
  set text2 [string map {A  a  B  C  c  E  e  H  K  k  M  O  o  P  p  T  U  u  X  x  Y  y  3  4  6  0  b  g  n } $text2]
  set text [tolower $text]
  set text " $text "
  set text2 [tolower $text2]
  set text2 " $text2 "
  regsub -all {([ \\`\~\!\@\#\$\%\^\&\*\(\)\_\-\+\=\{\}\[\]\;\:\'\"\<\>\,\.\/\?\|\\])+} $text " " text;
  set res ""
  set ch ""
  for {set i 0} {$i < [string length $text]} {incr i} {
    set newch [string index $text $i]
    if {$ch != $newch} {
      append res $newch
    }
    set ch $newch
  }
  set text $res
  for {set i 0} {$i < [string length $text2]} {incr i} {
    set newch [string index $text2 $i]
    if {$ch != $newch} {
      append res $newch
    }
    set ch $newch
  }
  set text2 $res
  set returncode 0
  set bwecount 0
  foreach i $BadWords {
    regsub -nocase -all {!SP!} $i " " i
    regsub -nocase -all {!PD!} $i \. i
    regsub -nocase -all {!CO!} $i \: i
    regsub -nocase -all {!SQ!} $i \' i
    regsub -nocase -all {!QL!} $i \; i
    regsub -nocase -all {!QT!} $i \" i
    regsub -nocase -all {!LT!} $i \< i
    regsub -nocase -all {!GT!} $i \> i
    regsub -nocase -all {!LP!} $i \( i
    regsub -nocase -all {!RP!} $i \) i
    regsub -nocase -all {!LB!} $i \{ i
    regsub -nocase -all {!RB!} $i \} i
    regsub -nocase -all {!LF!} $i \[ i
    regsub -nocase -all {!RF!} $i \] i
    regsub -nocase -all {!SL!} $i \\ i

    set mask [split [string trim $i] {}]
    regsub -all { } $mask {\s*} mask
    set mask ".*\\s+$mask\\s+.*"
    if {[regexp $mask $text] || [string match *$i* $text] || [regexp $mask $text2] || [string match *$i* $text2]} {
     incr bwecount
     }
  }
  set mask ""
  set text $res
  set bweecount 0
  foreach i $BadExepts {
    regsub -nocase -all {!SP!} $i " " i
    regsub -nocase -all {!PD!} $i \. i
    regsub -nocase -all {!CO!} $i \: i
    regsub -nocase -all {!SQ!} $i \' i
    regsub -nocase -all {!QL!} $i \; i
    regsub -nocase -all {!QT!} $i \" i
    regsub -nocase -all {!LT!} $i \< i
    regsub -nocase -all {!GT!} $i \> i
    regsub -nocase -all {!LP!} $i \( i
    regsub -nocase -all {!RP!} $i \) i
    regsub -nocase -all {!LB!} $i \{ i
    regsub -nocase -all {!RB!} $i \} i
    regsub -nocase -all {!LF!} $i \[ i
    regsub -nocase -all {!RF!} $i \] i
    regsub -nocase -all {!SL!} $i \\ i

    set mask [split [string trim $i] {}]
    regsub -all { } $mask {\s*} mask
    set mask ".*\\s+$mask\\s+.*"
    if {[regexp $mask $text] || [string match *$i* $text] || [regexp $mask $text2] || [string match *$i* $text2]}  {
    incr bweecount
    }
  }
  if {$bweecount < $bwecount} { return 1 } else { return 0 }
}

proc ::smartrm::CatchRaw {from keyword arg} {
  global botnick
  set arg [split $arg]
  set chan [string tolower [lindex $arg 0]]
  if {![validchan $chan]} {return 0}
  set nick [lindex [split $from !] 0]
  if {$nick == $botnick || $nick == "" || [string match *.* $nick]} {return 0}
  set text [join [lrange $arg 1 end]]
  set uhost [string trimleft [getchanhost $nick $chan] "~+-^="]
  set hand [nick2hand $nick $chan]
  ::smartrm::CatchMsg $nick $uhost $hand $chan $text
}

proc ::smartrm::CatchMsg {nick uhost hand chan text} {
  if [bw:active $chan] { 
   if [DetectMat $text] { 
      PunishUser $nick $uhost $hand $chan $text 
      return 1
      } 
  }
  return 0
}

proc ::smartrm::CatchAction {nick uhost hand chan key text} {
  CatchMsg $nick $uhost $hand $chan $text
}


proc ::smartrm::CatchNick {nick uhost hand chan {newnick ""}} {
  global botnick
  variable text
  variable lng_changenick
  if {$newnick == ""} {set newnick $nick}
  set text [lindex [split $newnick] 0]
  set testmode "[channel get $chan bwactionv]"
  if {[string match "v" $testmode]} {
     set banmask "[::smartrm::select_banmask $chan $uhost $nick]"
     if {![::smartrm::isinwarn $banmask $chan]} { 
         if {![isop $nick $chan] || ![ishalfop $nick $chan] || ![isvoice $nick $chan]} { putserv "MODE $chan +v $nick" }
      }
    }
  if {[DetectMat $text]} {
        set warm [::smartrm::warnmode $newnick $chan]
        if { $warm == 0 } { putserv "NOTICE $newnick :$lng_changenick" }
        if { $warm == 1 } { putserv "PRIVMSG $newnick :$lng_changenick" }
        if { $warm == 2 } { putserv "PRIVMSG $chan :$newnick, $lng_changenick" }
        set BanMask "$newnick\!\*\@\*"
        set kickcount [globalcounter $chan]
        set BanTime  [channel get $chan bwbantimer]
        newchanban $chan $BanMask $botnick $lng_changenick $BanTime
        if {[botisop $chan] || [botishalfop $chan]} { putserv "MODE $chan +b $BanMask" }
    }
}

proc ::smartrm::CatchTopic {nick uhost hand chan text} {
 variable lng_badtopic;
 variable Topics
 if {![bw:active $chan]} { return }
 if [DetectMat $text] {
   putcmdlog "\>$nick\> \0033$chan\003 = \0034$lng_badtopic\003"
   if {![check:bots $hand $chan]} { return 0 }
   PunishUser $nick $uhost $hand $chan $text
   if {![info exists Topics($chan)] || [DetectMat $Topics($chan)]} { set Topics($chan) "" }
# putserv "TOPIC $chan :$Topics($chan)"
  } else {
  set Topics($chan) [topic $chan]
  }
}

proc ::smartrm::CatchPart {nick uhost hand chan msg} {
 global botnick
 variable lng_banned; variable lng_minutes;
 if {![bw:active $chan]} { return }
  if {![channel get $chan bwbanquits]} { return }
   if {[DetectMat $msg]} {
    set kickcount [globalcounter $chan]
    set BanTime  [channel get $chan bwbantimer]
    set BanMask "[::smartrm::select_banmask $chan $uhost $nick]"
    set WarnMessage "[channel get $chan bwwarnmsgr]"
    set BanMessage "[channel get $chan bwbanmsgr]"
    set BanPubMessage "$BanMessage $lng_banned $BanTime $lng_minutes."
    newchanban $chan $BanMask $botnick $BanPubMessage $BanTime
    if {[botisop $chan] || [botishalfop $chan]} { putserv "MODE $chan +b $BanMask" }
 }  
 return
}

proc ::smartrm::isinwarn { banmask chan } {
 variable WarnList;
 foreach i $WarnList {
   if {[string match "*$chan\:$banmask\:*" $i]} {
     if {[regexp -nocase -- { "$chan\:$banmask\:(.*?)"} $i garb i]} { if {$i <= [expr [unixtime]]} { ::smartrm::removewarn $banmask $chan ; return 0 } }
     return 1
     }
   }
return 0
}

proc ::smartrm::isinblack { banmask chan } {
 variable BlackList;
 foreach i $BlackList {
  if {[string match "*$chan\:$banmask\:*" $i]} { 
    if {[regexp -nocase -- { "$chan\:$banmask\:(.*?)"} $i garb i]} { 
    if {$i <= [expr [unixtime]]} { ::smartrm::removeblack $banmask $chan ; return 0  } }
    return 1 
  }
 }
 return 0
}

proc ::smartrm::addwarn { banmask chan btime } {
 variable WarnList;
 set WarnList "$WarnList $chan\:$banmask\:$btime"
 return
}

proc ::smartrm::removewarn { banmask chan } {
 variable WarnList;
 set BWarnList ""
 foreach i $WarnList {
  if {![string match "*$chan\:$banmask\:*" $i]} { set BWarnList "$BWarnList $i" }
 }
 set WarnList "$BWarnList"
 return
}

proc ::smartrm::addblacklist { banmask chan btime } {
 variable BlackList;
 set BlackList "$BlackList $chan\:$banmask\:$btime"
 return
}

proc ::smartrm::removeblack { banmask chan } {
 variable BlackList;
 set BBlackList ""
 foreach i $BlackList {
  if {![string match "*$chan\:$banmask\:*" $i]} { set BBlackList "$BBlackList $i" }
 }
 set BlackList "$BBlackList"
 return
}

proc ::smartrm::punishmode { nick chan } {
 set testmode "[channel get $chan bwactionr]"
 if {[isvoice $nick $chan]} { set testmode "[channel get $chan bwactionv]" }
 if {[ishalfop $nick $chan]} { set testmode "[channel get $chan bwactionh]" }
 if {[isop $nick $chan]} { set testmode "[channel get $chan bwactiono]" } 

 if {[string match "none" $testmode]} { return 0 }
 if {[string match "w" $testmode]} { return 1 }
 if {[string match "k" $testmode]} { return 2 }
 if {[string match "b" $testmode]} { return 3 }
 if {[string match "wk" $testmode]} { return 4 }
 if {[string match "kb" $testmode]} { return 5 }
 if {[string match "wkb" $testmode]} { return 6 }
 if {[string match "wb" $testmode]} { return 7 }
 if {[string match "v" $testmode]} { return 8 }
 return 0
}

proc ::smartrm::warnmode { nick chan } {
 set testmode "[channel get $chan bwwarnmoder]"
 if {[isvoice $nick $chan]} { set testmode "[channel get $chan bwwarnmodev]" }
 if {[ishalfop $nick $chan]} { set testmode "[channel get $chan bwwarnmodeh]" }
 if {[isop $nick $chan]} { set testmode "[channel get $chan bwwarnmodeo]" }
 
 if {[string match "notice" $testmode]} { return 0 }
 if {[string match "private" $testmode]} { return 1 }
 if {[string match "channel" $testmode]} { return 2 }
 return 0
}


proc ::smartrm::PunishUser { nick uhost hand chan text } {
  variable kickcount;
  variable lng_minutes;
  variable lng_banned;
  global botnick;
# ::smartrm::checkdefaults $chan
#  if {![bw:active $chan]} { return }
  if {![check:bots $hand $chan]} { return }
  if {($nick == "*") || ($nick == $botnick)} { return }
  set kickcount [globalcounter $chan]
  set punm [::smartrm::punishmode $nick $chan]
  set warm [::smartrm::warnmode $nick $chan]
  set banmask "[::smartrm::select_banmask $chan $uhost $nick]"
  set BanTime [::smartrm::getbantime $nick $chan]
  set WarnTime [::smartrm::getwarntime $nick $chan]
  set WarnMessage "[::smartrm::getwarnmsg $nick $chan]"
  set BanMessage "[::smartrm::getbanmsg $nick $chan]"

##
  switch -- $punm {
  0 { return }
  1 { 
    if { $warm == 0 } { putserv "NOTICE $nick :$WarnMessage" }
    if { $warm == 1 } { putserv "PRIVMSG $nick :$WarnMessage" }
    if { $warm == 2 } { putserv "PRIVMSG $chan :$nick, $WarnMessage" }
    return
    }
  2 {
    if {[botisop $chan] || [botishalfop $chan]} { putserv "KICK $chan $nick :$BanMessage \:bwcount:\ \#$kickcount \:" }
    return
    }
  3 {
    set BanPubMessage "$BanMessage $lng_banned $BanTime $lng_minutes"
    if {![check:friend $hand $chan]} { return }
    newchanban $chan $banmask $botnick $BanPubMessage $BanTime
    return
    }
  4 {
    if {![::smartrm::isinwarn $banmask $chan]} {
            ::smartrm::addwarn $banmask $chan "[expr [unixtime] + $WarnTime*60]"
            if { $warm == 0 } { putserv "NOTICE $nick :$WarnMessage" }
            if { $warm == 1 } { putserv "PRIVMSG $nick :$WarnMessage" }
            if { $warm == 2 } { putserv "PRIVMSG $chan :$nick, $WarnMessage" }
          } else {
            if {[botisop $chan] || [botishalfop $chan]} { putserv "KICK $chan $nick :$BanMessage \:bwcount:\ \#$kickcount \:" }
        }
     return
    }
  5 {
    if {![::smartrm::isinwarn $banmask $chan]} {
            ::smartrm::addwarn $banmask $chan "[expr [unixtime] + $WarnTime*60]"
            if { $warm == 0 } { putserv "NOTICE $nick :$WarnMessage" }
            if { $warm == 1 } { putserv "PRIVMSG $nick :$WarnMessage" }
            if { $warm == 2 } { putserv "PRIVMSG $chan :$nick, $WarnMessage" }
            if {[botisop $chan] || [botishalfop $chan]} { putserv "KICK $chan $nick :$BanMessage \:bwcount:\ \#$kickcount \:" }
          } else {
          set BanPubMessage "$BanMessage $lng_banned $BanTime $lng_minutes."
          if {![check:friend $hand $chan]} { return }
          newchanban $chan $banmask $botnick $BanPubMessage $BanTime
          if {[botisop $chan] || [botishalfop $chan]} {
            putserv "MODE $chan +b $banmask" 
            putserv "KICK $chan $nick :$BanMessage \:bwcount:\ \#$kickcount \:" 
            }
         }
     return
    }
  6 {
    if {![::smartrm::isinblack $banmask $chan]} {
        if {![::smartrm::isinwarn $banmask $chan]} { 
             ::smartrm::addwarn $banmask $chan "[expr [unixtime] + $WarnTime*60]"
             if { $warm == 0 } { putserv "NOTICE $nick :$WarnMessage" }
             if { $warm == 1 } { putserv "PRIVMSG $nick :$WarnMessage" }
             if { $warm == 2 } { putserv "PRIVMSG $chan :$nick, $WarnMessage" }
           } else {
            ::smartrm::addblacklist $banmask $chan "[expr [unixtime] + $WarnTime*60]"
            if {[botisop $chan] || [botishalfop $chan]} { putserv "KICK $chan $nick :$BanMessage \:bwcount:\ \#$kickcount \:" }
           }
        } else {
          set BanPubMessage "$BanMessage $lng_banned $BanTime $lng_minutes."
          if {![check:friend $hand $chan]} { return }
          newchanban $chan $banmask $botnick $BanPubMessage $BanTime                  
          if {[botisop $chan] || [botishalfop $chan]} {
            putserv "MODE $chan +b $banmask" 
            putserv "KICK $chan $nick :$BanMessage \:bwcount:\ \#$kickcount \:" 
            }
        }              
     return
    }
  7 {
    if {![::smartrm::isinwarn $banmask $chan]} {
            ::smartrm::addwarn $banmask $chan "[expr [unixtime] + $WarnTime*60]"
            if { $warm == 0 } { putserv "NOTICE $nick :$WarnMessage" }
            if { $warm == 1 } { putserv "PRIVMSG $nick :$WarnMessage" }
            if { $warm == 2 } { putserv "PRIVMSG $chan :$nick, $WarnMessage" }
          } else {
          set BanPubMessage "$BanMessage $lng_banned $BanTime $lng_minutes."
          if {![check:friend $hand $chan]} { return }
          newchanban $chan $banmask $botnick $BanPubMessage $BanTime
          if {[botisop $chan] || [botishalfop $chan]} {
            putserv "MODE $chan +b $banmask" 
            putserv "KICK $chan $nick :$BanMessage \:bwcount:\ \#$kickcount \:" 
            }
         }
     return
    }
  8 {
    if {![::smartrm::isinwarn $banmask $chan]} {
            ::smartrm::addwarn $banmask $chan "[expr [unixtime] + $WarnTime*60]"
            if { $warm == 0 } { putserv "NOTICE $nick :$WarnMessage" }
            if { $warm == 1 } { putserv "PRIVMSG $nick :$WarnMessage" }
            if { $warm == 2 } { putserv "PRIVMSG $chan :$nick, $WarnMessage" }
            putserv "MODE $chan -v $nick"
          } 
     return
    }
  } 
}


proc ::smartrm::BadWordsOn {nick uhost hand chan arg} {
variable lng_bwonchan; variable lng_on;
catch {
 if {![validchan $chan]} {
  return 0
  }
  channel set $chan +badwords
  savechannels
  ::smartrm::checkdefaults $chan
  putserv "NOTICE $nick :$lng_bwonchan $chan $lng_on"
  return 
 } 
}

proc ::smartrm::BadWordsOff {nick uhost hand chan arg} {
variable lng_bwonchan; variable lng_off;
catch {
 if {![validchan $chan]} {  return 0  }
  channel set $chan -badwords
  savechannels
  putserv "NOTICE $nick :$lng_bwonchan $chan $lng_off"
  return
 }
}


#############################
# just a f**kin counters ;) #
#############################
proc ::smartrm::globalcounter {chan} {
 variable lng_cfnotf;
 global botnick
 set bwcounterfile "$chan.bwc"
   if {![file exists $bwcounterfile]} {
     putcmdlog "$lng_cfnotf"
     set file [open $bwcounterfile "w"]
     puts $file 1
     close $file 
     }
    set file [open $bwcounterfile "r"]
    set currentkicks [gets $file]
    close $file
    set file [open $bwcounterfile "w"]
    puts $file [expr $currentkicks + 1]
    close $file
    set file [open $bwcounterfile "r"]
    set currentkicks [gets $file]
    close $file
   return $currentkicks
}

proc ::smartrm::getglobalcounter {chan} {
 variable lng_cfnotf;
 global botnick
 set bwcounterfile "$chan.bwc"
   if {![file exists $bwcounterfile]} {
     putcmdlog "$lng_cfnotf"
     set file [open $bwcounterfile "w"]
     puts $file 1
     close $file 
     }
    set file [open $bwcounterfile "r"]
    set currentkicks [gets $file]
    close $file
   return $currentkicks
}

proc ::smartrm::chwarntime { nick uhost hand chan arg } {
 variable lng_chwarntime; variable lng_chwarntimeuse; variable lng_chwarntimetargets; variable lng_chwarntimeexample; variable lng_chwarntimefor;
 variable lng_forop; variable lng_forhop; variable lng_forvoice; variable lng_forreg; variable lng_minutes; variable lng_modena; variable lng_wrongargs;
 regsub -all -- {\\} $arg {\\} arg; regsub -all -- {\"} $arg {\"} arg; regsub -all -- {\[} $arg {\[} arg
 regsub -all -- {\]} $arg {\]} arg; regsub -all -- {\}} $arg {\}} arg; regsub -all -- {\{} $arg {\{} arg
 regsub -all -- {\(} $arg {\(} arg; regsub -all -- {\)} $arg {\)} arg; regsub -all -- {\.} $arg {\.} arg
 regsub -all -- {\*} $arg {.*} arg; regsub -all -- {\,} $arg {\,} arg; regsub -all -- {\?} $arg {.?} arg
if {[llength $arg] != 2} {
 putserv "NOTICE $nick :$lng_chwarntime"
 putserv "NOTICE $nick :$lng_chwarntimeuse"
 putserv "NOTICE $nick :$lng_chwarntimetargets"
 putserv "NOTICE $nick :$lng_chwarntimeexample"
 return
 }
set chtrgt "[lindex $arg 0]"
set arg [lindex $arg 1]
if {([string compare "" $arg]) && \
      (![regexp \[^0-9\] $arg])} then {
    if {[string match -nocase "r" $chtrgt]} {
      putserv "NOTICE $nick :$lng_chwarntimefor $lng_forreg\: $arg $lng_minutes"
      channel set $chan bwwarntimer $arg
      return
      }
    if {[string match -nocase "v" $chtrgt]} {
      putserv "NOTICE $nick :$lng_chwarntimefor $lng_forvoice\: $arg $lng_minutes"
      channel set $chan bwwarntimev $arg
      return
      }
    if {[string match -nocase "h" $chtrgt]} {
      putserv "NOTICE $nick :$lng_chwarntimefor $lng_forhop\: $arg $lng_minutes"
      channel set $chan bwwarntimeh $arg
      return
      }
    if {[string match -nocase "o" $chtrgt]} {
      putserv "NOTICE $nick :$lng_chwarntimefor $lng_forop\: $arg $lng_minutes"
      channel set $chan bwwarntimeo $arg
      return
      }
    putserv "NOTICE $nick :$lng_modena"
 }
 putserv "NOTICE $nick :$lng_wrongargs"
 return
}

proc ::smartrm::chbantime { nick uhost hand chan arg } {
 variable lng_chbantime;
 variable lng_chbantimeuse;
 variable lng_chbantimetargets;
 variable lng_chbantimeexample;
 variable lng_chbantimefor;
 variable lng_forhop;
 variable lng_forvoice;
 variable lng_forreg;
 variable lng_minutes;
 variable lng_modena;
 variable lng_wrongargs;
regsub -all -- {\\} $arg {\\} arg; regsub -all -- {\"} $arg {\"} arg; regsub -all -- {\[} $arg {\[} arg
regsub -all -- {\]} $arg {\]} arg; regsub -all -- {\}} $arg {\}} arg; regsub -all -- {\{} $arg {\{} arg
regsub -all -- {\(} $arg {\(} arg; regsub -all -- {\)} $arg {\)} arg; regsub -all -- {\.} $arg {\.} arg
regsub -all -- {\*} $arg {.*} arg; regsub -all -- {\,} $arg {\,} arg; regsub -all -- {\?} $arg {.?} arg
if {[llength $arg] != 2} {
 putserv "NOTICE $nick :$lng_chbantime"
 putserv "NOTICE $nick :$lng_chbantimeuse"
 putserv "NOTICE $nick :$lng_chbantimetargets"
 putserv "NOTICE $nick :$lng_chbantimeexample"
 return
 }
set chtrgt "[lindex $arg 0]"
set arg [lindex $arg 1]
if {([string compare "" $arg]) && \
      (![regexp \[^0-9\] $arg])} then {
    if {[string match -nocase "r" $chtrgt]} {
      putserv "NOTICE $nick :$lng_chbantimefor $lng_forreg\: $arg $lng_minutes"
      channel set $chan bwbantimer $arg
      return
      }
    if {[string match -nocase "v" $chtrgt]} {
      putserv "NOTICE $nick :$lng_chbantimefor $lng_forvoice\: $arg $lng_minutes"
      channel set $chan bwbantimev $arg
      return
      }
    if {[string match -nocase "h" $chtrgt]} {
      putserv "NOTICE $nick :$lng_chbantimefor $lng_forhop\: $arg $lng_minutes"
      channel set $chan bwbantimeh $arg
      return
      }
    putserv "NOTICE $nick :$lng_modena"
 }
 putserv "NOTICE $nick :$lng_wrongargs"
 return
}

proc ::smartrm::chebanmsg { nick uhost hand chan text } {
 variable lng_chebanmsguse;
 variable lng_chebanmsgtargets;
 variable lng_chebanmsgexample;
 variable lng_chebanmsgfor;
 variable lng_forhop;
 variable lng_forvoice;
 variable lng_forreg;
 variable lng_modena;

if {[llength $text] < 2} {
 putserv "NOTICE $nick :$lng_chebanmsguse"
 putserv "NOTICE $nick :$lng_chebanmsgtargets"
 putserv "NOTICE $nick :$lng_chebanmsgexample"
 return
 }
regsub -all -- {\;} $text "\;" text;
regsub -all -- {\\} $text {\\} text; regsub -all -- {\"} $text {\"} text; regsub -all -- {\[} $text {\[} text
regsub -all -- {\]} $text {\]} text; regsub -all -- {\}} $text {\}} text; regsub -all -- {\{} $text {\{} text
regsub -all -- {\(} $text {\(} text; regsub -all -- {\)} $text "\)" text; regsub -all -- {\.} $text {\.} text
regsub -all -- {\*} $text {.*} text; regsub -all -- {\,} $text {\,} text; regsub -all -- {\?} $text {.?} text

set chtrgt "[lindex $text 0]"
set text "[lrange $text 1 end]"
 if {[string match -nocase "r" $chtrgt]} {
  putserv "NOTICE $nick :$lng_chebanmsgfor $lng_forreg\: $text"
  channel set $chan bwbanmsgr "$text"
  return
  }
 if {[string match -nocase "v" $chtrgt]} {
  putserv "NOTICE $nick :$lng_chebanmsgfor $lng_forvoice\: $text"
  channel set $chan bwbanmsgv "$text"
  return
  }
 if {[string match -nocase "h" $chtrgt]} {
  putserv "NOTICE $nick :$lng_chebanmsgfor $lng_forhop\: $text"
  channel set $chan bwbanmsgh "$text"
  return
  }
putserv "NOTICE $nick :$lng_modena"
return
}

proc ::smartrm::chewarnmsg { nick uhost hand chan text } {
 variable lng_chewarnmsguse;
 variable lng_chewarnmsgtargets;
 variable lng_chewarnmsgexample;
 variable lng_warnfor;
 variable lng_forop;
 variable lng_forhop;
 variable lng_forvoice;
 variable lng_forreg;
 variable lng_modena;
if {[llength $text] < 2} {
 putserv "NOTICE $nick :$lng_chewarnmsguse"
 putserv "NOTICE $nick :$lng_chewarnmsgtargets"
 putserv "NOTICE $nick :$lng_chewarnmsgexample"
 return
 }
regsub -all -- {\;} $text {\;} text;
regsub -all -- {\\} $text {\\} text; regsub -all -- {\"} $text {\"} text; regsub -all -- {\[} $text {\[} text
regsub -all -- {\]} $text {\]} text; regsub -all -- {\}} $text {\}} text; regsub -all -- {\{} $text {\{} text
regsub -all -- {\(} $text {\(} text; regsub -all -- {\)} $text {\)} text; regsub -all -- {\.} $text {\.} text
regsub -all -- {\*} $text {.*} text; regsub -all -- {\,} $text {\,} text; regsub -all -- {\?} $text {.?} text

set chtrgt "[lindex $text 0]"
set text "[lrange $text 1 end]"
 if {[string match -nocase "r" $chtrgt]} {
  putserv "NOTICE $nick :$lng_warnfor $lng_forreg\: $text"
  channel set $chan bwwarnmsgr "$text"
  return
  }
 if {[string match -nocase "v" $chtrgt]} {
  putserv "NOTICE $nick :$lng_warnfor $lng_forvoice\: $text"
  channel set $chan bwwarnmsgv "$text"
  return
  }
 if {[string match -nocase "h" $chtrgt]} {
  putserv "NOTICE $nick :$lng_warnfor $lng_forhop\: $text"
  channel set $chan bwwarnmsgh "$text"
  return
  }
 if {[string match -nocase "o" $chtrgt]} {
  putserv "NOTICE $nick :$lng_warnfor $lng_forop\: $text"
  channel set $chan bwwarnmsgo "$text"
  return
  }
putserv "NOTICE $nick :$lng_modena"
return
}


proc ::smartrm::chewarnmode { nick uhost hand chan text } {
 variable lng_chewarnmuse; variable lng_chewarnmtargets; variable lng_chewarnmmode; variable lng_chewarnmexample; variable lng_wrongmode;
 variable lng_chewarnm; variable lng_forop; variable lng_forvoice; variable lng_forhop; variable lng_forreg;
 
 if {[llength $text] < 2} {
  putserv "NOTICE $nick :$lng_chewarnmuse"
  putserv "NOTICE $nick :$lng_chewarnmtargets"
  putserv "NOTICE $nick :$lng_chewarnmmode"
  putserv "NOTICE $nick :$lng_chewarnmexample"
  return
  }
 regsub -all -- {\;} $text {\;} text;
 regsub -all -- {\\} $text {\\} text; regsub -all -- {\"} $text {\"} text; regsub -all -- {\[} $text {\[} text
 regsub -all -- {\]} $text {\]} text; regsub -all -- {\}} $text {\}} text; regsub -all -- {\{} $text {\{} text
 regsub -all -- {\(} $text {\(} text; regsub -all -- {\)} $text {\)} text; regsub -all -- {\.} $text {\.} text
 regsub -all -- {\*} $text {.*} text; regsub -all -- {\,} $text {\,} text; regsub -all -- {\?} $text {.?} text

set chtrgt "[lindex $text 0]"
set text "[lrange $text 1 end]"
 if {![string match "notice" $text] && ![string match "private" $text] && ![string match "channel" $text]} { 
  putserv "NOTICE $nick :$lng_wrongmode"
  return 
 }
 if {[string match -nocase "r" $chtrgt]} {
  channel set $chan bwwarnmoder "$text"
  putserv "NOTICE $nick :$lng_chewarnm $lng_forreg\: $text"
  return
  }
 if {[string match -nocase "v" $chtrgt]} {
  channel set $chan bwwarnmodev "$text"
  putserv "NOTICE $nick :$lng_chewarnm $lng_forvoice\: $text"
  return
  }
 if {[string match -nocase "h" $chtrgt]} {
  channel set $chan bwwarnmodeh "$text"
  putserv "NOTICE $nick :$lng_chewarnm $lng_forhop\: $text"
  return
  }
 if {[string match -nocase "o" $chtrgt]} {
  channel set $chan bwwarnmodeo "$text"
  putserv "NOTICE $nick :$lng_chewarnm $lng_forop\: $text"
  return
  }
}

proc ::smartrm::cheactmode { nick uhost hand chan text } {
 variable lng_cheactmuse; variable lng_cheactmtargets; variable lng_cheactmmode; variable lng_cheactmexample; variable lng_wrongmode;
 variable lng_wrongactmodeo; variable lng_cheactm; variable lng_forop; variable lng_forvoice; variable lng_forhop; variable lng_forreg;

if {[llength $text] < 2} {
 putserv "NOTICE $nick :$lng_cheactmuse"
 putserv "NOTICE $nick :$lng_cheactmtargets"
 putserv "NOTICE $nick :$lng_cheactmmode"
 putserv "NOTICE $nick :$lng_cheactmexample"
 return
 }
regsub -all -- {\;} $text "\;" text;
regsub -all -- {\\} $text "\\" text; regsub -all -- {\"} $text {\"} text; regsub -all -- {\[} $text {\[} text
regsub -all -- {\]} $text "\]" text; regsub -all -- {\}} $text {\}} text; regsub -all -- {\{} $text {\{} text
regsub -all -- {\(} $text "\(" text; regsub -all -- {\)} $text {\)} text; regsub -all -- {\.} $text {\.} text
regsub -all -- {\*} $text ".*" text; regsub -all -- {\,} $text {\,} text; regsub -all -- {\?} $text {.?} text

set chtrgt "[lindex $text 0]"
set text "[lrange $text 1 end]"
 if { ![string match "none" $text] && ![string match "k" $text] && ![string match "b" $text] && ![string match "w" $text] && ![string match "wk" $text] && ![string match "kb" $text] && ![string match "wb" $text] && ![string match "wkb" $text] && ![string match "v" $text] } { 
  putserv "NOTICE $nick :$lng_wrongmode"
  return 
 }
 if {[string match -nocase "r" $chtrgt]} {
  if {[string match "v" $text]} { putserv "NOTICE $nick :$lng_wrongmode" ;  return  }
  channel set $chan bwactionr "$text" 
  putserv "NOTICE $nick :$lng_cheactm $lng_forreg\: $text"
  return
  }
 if {[string match -nocase "v" $chtrgt]} {
  channel set $chan bwactionv "$text" 
  putserv "NOTICE $nick :$lng_cheactm $lng_forvoice\: $text"
  return
  }
 if {[string match -nocase "h" $chtrgt]} {
  if {[string match "v" $text]} { putserv "NOTICE $nick :$lng_wrongmode" ;  return  }
  channel set $chan bwactionh "$text" 
  putserv "NOTICE $nick :$lng_cheactm $lng_forhop\: $text"
  return
  }
 if {[string match -nocase "o" $chtrgt]} {
  if { ![string match "none" $text] && ![string match "k" $text] && ![string match "w" $text] && ![string match "wk" $text] } { 
    putserv "NOTICE $nick :$lng_wrongactmodeo"
    return 
    }
  channel set $chan bwactiono "$text" 
  putserv "NOTICE $nick :$lng_cheactm $lng_forop\: $text"
  return
  }
}

proc ::smartrm::chbanmask { nick uhost hand chan arg } {
 variable lng_bmaskuse1; variable lng_bmaskuse2; variable lng_bmaskcur; variable lng_bmaskwrongnum;
 variable lng_bmaskselected;
 if {[llength $arg] < 1} {
  putserv "NOTICE $nick :$lng_bmaskuse1"
  putserv "NOTICE $nick :$lng_bmaskuse2"
  putserv "NOTICE $nick :$lng_bmaskcur\: [channel get $chan bwbanmask]"
  return
  }
 regsub -all -- {\;} $arg "\;" arg;
 regsub -all -- {\\} $arg "\\" arg; regsub -all -- {\"} $arg {\"} arg; regsub -all -- {\[} $arg {\[} arg
 regsub -all -- {\]} $arg "\]" arg; regsub -all -- {\}} $arg {\}} arg; regsub -all -- {\{} $arg {\{} arg
 regsub -all -- {\(} $arg "\(" arg; regsub -all -- {\)} $arg {\)} arg; regsub -all -- {\.} $arg {\.} arg
 regsub -all -- {\*} $arg ".*" arg; regsub -all -- {\,} $arg {\,} arg; regsub -all -- {\?} $arg {.?} arg

 if {([string compare "" $arg]) && (![regexp \[^0-9\] $arg])} then {
       if {$arg < 1 && $arg > 20 } {
         putserv "NOTICE $nick :$lng_bmaskwrongnum"
         channel set $chan bwbanmask 1 
         } else { 
         putserv "NOTICE $nick :$lng_bmaskselected\: $arg"       
         channel set $chan bwbanmask $arg
         return
         }
      }
 if {[string match -nocase "list" $arg]} {
   putserv "PRIVMSG $nick : 1 \: \*\!\*\@some\.host\.com  2 \: \*\!\*\@\*\.host\.com  3 \: \*\!\*ident\@some\.domain\.com  4 \: \*\!\*ident\@\*\.host\.com"
   putserv "PRIVMSG $nick : 5 \: \*\!\*ident\*\@\*\.host\.com  6 \: \*\!\*ident\*\@some\.host\.com  7 \: nick\*\!\*\@\*\.host\.com  8 \: \*nick\*\!\*\@\*\.host\.com"
   putserv "PRIVMSG $nick : 9 \: nick\*\!\*\@some\.host\.com  10 \: \*nick\*\!\*\@some\.host\.com  11 \: nick\!ident\@some\.host\.com  12 \: nick\!ident\@\*\.host\.com"
   putserv "PRIVMSG $nick : 13 \: \*nick\*\!\*ident\@some\.host\.com  14 \: nick\*\!\*ident\*\@some\.host\.com  15 \: \*nick\*\!\*ident\*\@some\.host\.com  16 \: nick\!\*ident\*\@some\.host\.com"
   putserv "PRIVMSG $nick : 17 \: nick\*\!\*ident\@\*\.host\.com  18 \: nick\*\!\*ident\*\@\*\.host\.com  19 \: \*nick\*\!\*ident\@\*\.host\.com  20 \: \*nick\*\!\*ident\*\@\*\.host\.com"
   return
   }
}

proc ::smartrm::bwstats { nick uhost hand chan text } {
 variable BadWords; variable BadExepts;
 variable lng_bwstats; variable lng_badwords; variable lng_excepts; variable lng_totalcount; variable lng_times;
 if {![bw:active $chan]} { return }
 set totalbw 0
 foreach element $BadWords { incr totalbw }
 set totalbe 0
 foreach element $BadExepts { incr totalbe }
 putserv "NOTICE $nick :$lng_bwstats"
 putserv "NOTICE $nick : $totalbw $lng_badwords\: $totalbe $lng_excepts"
 set kickcount [getglobalcounter $chan]
 putserv "NOTICE $nick :$lng_totalcount $kickcount $lng_times"
}

proc ::smartrm::bwstatus { nick uhost hand chan text } {
 variable lng_curconfig; variable lng_curmode; variable lng_curwarn; variable lng_curwarntime; variable lng_curbantime;
 putserv "NOTICE $nick :$lng_curconfig"
 putserv "NOTICE $nick :$lng_curmode\: r\:[channel get $chan bwactionr] v\:[channel get $chan bwactionv] h\:[channel get $chan bwactionh] o\:[channel get $chan bwactiono]"
 putserv "NOTICE $nick :$lng_curwarn\: r\:[channel get $chan bwwarnmoder] v\:[channel get $chan bwwarnmodev] h\:[channel get $chan bwwarnmodeh] o\:[channel get $chan bwwarnmodeo]"
 putserv "NOTICE $nick :$lng_curwarntime\: r\:[channel get $chan bwwarntimer] v\:[channel get $chan bwwarntimev] h\:[channel get $chan bwwarntimeh] o\:[channel get $chan bwwarntimeo]"
 putserv "NOTICE $nick :$lng_curbantime\: r\:[channel get $chan bwbantimer] v\:[channel get $chan bwbantimev] h\:[channel get $chan bwbantimeh]"
}

proc ::smartrm::bwhelp { nick uhost hand chan text } {
 variable lng_bwhelp1; variable lng_bwhelp2; variable lng_bwhelp3; variable lng_bwhelp4; variable lng_bwhelp5; variable lng_bwhelp6; variable lng_bwhelp7; variable lng_bwhelp8; variable lng_bwhelp9;
 putserv "NOTICE $nick :$lng_bwhelp1"
 putserv "NOTICE $nick :$lng_bwhelp2"
 putserv "NOTICE $nick :$lng_bwhelp3"
 putserv "NOTICE $nick :$lng_bwhelp4"
 putserv "NOTICE $nick :$lng_bwhelp5"
 putserv "NOTICE $nick :$lng_bwhelp6"
 putserv "NOTICE $nick :$lng_bwhelp7"
 putserv "NOTICE $nick :$lng_bwhelp8"
 putserv "NOTICE $nick :$lng_bwhelp9"
 return
}

proc ::smartrm::bwver {nick uhost hand chan text } {
 variable lng_bwvermsg1; variable lng_bwvermsg2; variable lng_bwvermsg3; variable lng_bwvermsg4; variable lng_bwvermsg5;
 putserv "NOTICE $nick :$lng_bwvermsg1"
 putserv "NOTICE $nick :$lng_bwvermsg2"
 putserv "NOTICE $nick :$lng_bwvermsg3"
 putserv "NOTICE $nick :$lng_bwvermsg4"
 putserv "NOTICE $nick :$lng_bwvermsg5"
 return
} 

proc ::smartrm::bwchannels {nick uhost hand chan text } {
 variable lng_bwchans;
 set bwchanlist ""
 foreach i [channels] {
  if {[bw:active $i]} {
   set bwchanmode "[channel get $i bwactionr]"
   set bwchanlist "$bwchanlist $i\:$bwchanmode" 
   }
 }
 putserv "NOTICE $nick :$lng_bwchans"
 putserv "NOTICE $nick :$bwchanlist"
}

proc ::smartrm::bwBanQuits { nick uhost hand chan text } {
 variable lng_bwbanquits
 variable lng_bwbanquitsuse
 variable lng_bwbanquitson
 variable lng_bwbanquitsoff
 set indata "[lindex $text 0]"
 if {[llength $indata] == 0} {
    putserv "NOTICE $nick :$lng_bwbanquits"
    putserv "NOTICE $nick :$lng_bwbanquitsuse"
    }
 if {[string match -nocase "on" $indata]}  { channel set $chan +bwbanquits }
 if {[string match -nocase "off" $indata]} { channel set $chan -bwbanquits }
 if {[string match -nocase "0" $indata]}   { channel set $chan -bwbanquits }
 if {[string match -nocase "1" $indata]}   { channel set $chan +bwbanquits }
 if {[channel get $chan bwbanquits]} {
    putserv "NOTICE $nick :$lng_bwbanquitson"
    } else { 
    putserv "NOTICE $nick :$lng_bwbanquitsoff"
    }
 return
}

################################

bind raw - PRIVMSG       ::smartrm::CatchRaw
bind raw - NOTICE        ::smartrm::CatchRaw
bind join - *            ::smartrm::CatchNick
bind nick - *            ::smartrm::CatchNick
bind ctcp - ACTION       ::smartrm::CatchAction
bind topc - *            ::smartrm::CatchTopic
bind part - *            ::smartrm::CatchPart

bind pub o-o !bwoff      ::smartrm::BadWordsOff
bind pub o-o !bwon       ::smartrm::BadWordsOn
bind pub o-o !bwbanquits ::smartrm::bwBanQuits
bind msg mn !bwadd       ::smartrm::bwadd
bind msg mn !bwdel       ::smartrm::bwdel
bind msg mn !bweadd      ::smartrm::bweadd
bind msg mn !bwedel      ::smartrm::bwedel

bind pub o-o !bwwarntime ::smartrm::chwarntime
bind pub o-o !bwbantime  ::smartrm::chbantime
bind pub o-o !bwbanmsg   ::smartrm::chebanmsg
bind pub o-o !bwwarnmsg  ::smartrm::chewarnmsg
bind pub o-o !bwwarnmode ::smartrm::chewarnmode
bind pub o-o !bwactmode  ::smartrm::cheactmode
bind pub o-o !bwbanmask  ::smartrm::chbanmask
bind pub - !bwstats      ::smartrm::bwstats
bind pub - !bwstatus     ::smartrm::bwstatus
bind pub - !bwhelp       ::smartrm::bwhelp
bind pub - !bwver        ::smartrm::bwver
bind pub - !bwchannels   ::smartrm::bwchannels


::smartrm::bwload